#include "SingleLinkList.h"
#include <stdlib.h>

int main(int argc, char* argv[])
{
	int i;
	ElemType Elem;
	LinkList* pListHead;  // A pointer to the header of a single linked list
	LinkList* pListNode;  // Single list node pointer
	LinkList* pListHeadTemp;
	
	//
	// Initializes the header node of a single linked list
	//
	pListHead = (LinkList*)malloc(sizeof(LinkList));
	pListHead->next = NULL;
	
	//
	// Initializes the nodes of a single list
	//
	for (i=8; i>0; i--)
	{
		pListNode = (LinkList*)malloc(sizeof(LinkList));
		pListNode->data = i;
		
		pListNode->next = pListHead->next;
		pListHead->next = pListNode;
	}
	
	//
	// Delete the ith node
	//
	Delete(pListHead,  3, &Elem);
	Delete(pListHead, 20, &Elem);	// Illegal deletion of location. Deletion failed.
	
    pListHeadTemp = pListHead;
	pListNode = pListHeadTemp->next;
	while (pListNode != NULL)
	{
		printf("%d ", pListNode->data);
		pListNode = pListNode->next;		
	}
	printf("\n");
	
	//
	// Destroy single linked list
	//
	while (pListHead->next != NULL)
	{
		pListNode = pListHead->next;
		pListHead->next = pListNode->next;
		free(pListNode);
	}
	free(pListHead);

	return 0;
}

/*
function:
	Delete the specified node.

parameter:
	pListHead -- A pointer to the head of a single linked list
	i -- Delete the location of the node.Count from 1.
	pElem -- Returns the value of the deleted node.
	  
returned value:
	Returns 1 if deletion succeeds
	Returns 1 if deletion fails
*/
int Delete(LinkList* pListHead, int i, ElemType* pElem)
{
	LinkList* pListNode;		// Node pointer
	
	//
	// TODO: Add the code here
	//
	
	return 0;
}
